#include <windows.h>
#include <mydialog.h>

int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE, LPSTR lpCmdLine, INT nCmdShow)
{
   AppClass App(hInstance);

   MyDialogClass Dialog(0);
   Dialog.Run();
   return 0;
}

UINT MyDialogClass::Run()
{
   return ModalDialogClass::DoDialog(this, Parent, IDD_MAIN_DIALOG);
}

void MyDialogClass::OnInitDialog()
{
   Next = SetClipboardViewer(WindowHandle);
   HIcon = LoadIcon(AppClass::GetApp()->GetInstanceHandle(), MAKEINTRESOURCE(IDD_MAIN_DIALOG_ICON));
   TrayIcon = LoadIcon(AppClass::GetApp()->GetInstanceHandle(), MAKEINTRESOURCE(IDD_TRAY_ICON));
   SendMessage(WM_SETICON, ICON_SMALL, (LPARAM )TrayIcon);
   SendMessage(WM_SETICON, ICON_BIG, (LPARAM )HIcon);
}

bool MyDialogClass::OnChangeCliboardChain(HWND aRemove, HWND aNext)
{
   if(aNext == aRemove)
      Next = aNext;
   else
      ::SendMessage(Next, WM_CHANGECBCHAIN, (WPARAM )aRemove, (WPARAM )aNext);

   return false;
}

bool MyDialogClass::DrawClipboard()
{
   if(!OpenClipboard(WindowHandle))
   {
      SetDlgItemText(IDC_LINK_TEXT, "Failed to open");
      return false;
   }
   HANDLE handle;
   if((handle = GetClipboardData(CF_TEXT)) == 0)
   {
      SetDlgItemText(IDC_LINK_TEXT, "Not text format");
      CloseClipboard();
      return false;
   }
   char *s;
   if((s = (char *)GlobalLock(handle)) == 0)
   {
      SetDlgItemText(IDC_LINK_TEXT, "Failed to lock");
      CloseClipboard();
      return false;
   }
   char Temp[1024];
   strncpy(Temp, s, DrawMin(strlen(s) + 1, sizeof(Temp)));
   Temp[sizeof(Temp) - 1] = 0;

   GlobalUnlock(handle);
   CloseClipboard();
   if(strstr(Temp, "http") == Temp)
   {
      SetDlgItemText(IDC_LINK_TEXT, Temp);
      ShellExecute(WindowHandle, "open", Temp, 0, "", SW_SHOW);
   }
   else
   {
      SetDlgItemText(IDC_LINK_TEXT, "Not a URL");
   }
   return false;
}

void MyDialogClass::Minimize()
{
   if(!IsMin)
   {
      ShowWindow(WindowHandle, SW_HIDE);
      NOTIFYICONDATA NotifyIconData;
      memset(&NotifyIconData, 0, sizeof(NOTIFYICONDATA));
      NotifyIconData.cbSize = sizeof(NOTIFYICONDATA);
      NotifyIconData.uID = 123;
      NotifyIconData.hWnd = WindowHandle;
      NotifyIconData.hIcon = TrayIcon;
      NotifyIconData.uFlags = NIF_ICON | NIF_TIP | NIF_MESSAGE;
      NotifyIconData.uCallbackMessage = IDC_TRAY_MSG;
      strcpy(NotifyIconData.szTip, "ClipMon");
      Shell_NotifyIcon(NIM_ADD, &NotifyIconData);
      IsMin = true;
   }
}

void MyDialogClass::UnMinimize()
{
   if(IsMin)
   {
      ShowWindow(WindowHandle, SW_SHOW);
      NOTIFYICONDATA NotifyIconData;
      memset(&NotifyIconData, 0, sizeof(NOTIFYICONDATA));
      NotifyIconData.cbSize = sizeof(NOTIFYICONDATA);
      NotifyIconData.uID = 123;
      NotifyIconData.hWnd = WindowHandle;
      NotifyIconData.hIcon = TrayIcon;
      NotifyIconData.uFlags = NIF_ICON | NIF_TIP | NIF_MESSAGE;
      NotifyIconData.uCallbackMessage = IDC_TRAY_MSG;
      strcpy(NotifyIconData.szTip, "ClipMon");
      Shell_NotifyIcon(NIM_DELETE, &NotifyIconData);
      IsMin = false;
   }
}

AppClass *AppClass::Me;
ModalDialogClass::DialogMapClass ModalDialogClass::DialogMap;
