#ifndef MYDIALOG_H_INC
#define MYDIALOG_H_INC

#include "dialog.h"
#include "resource.h"
#include <windows.h>
#include <commctrl.h>

class MyDialogClass : public ModalDialogClass
{
public:
   MyDialogClass(HWND aParent) : Parent(aParent), IsMin(false)
   {
   }
   virtual ~MyDialogClass()
   {
   }
   UINT Run();
   virtual void OnInitDialog();
   virtual bool OnChangeCliboardChain(HWND aRemove, HWND aNext);
   virtual bool DrawClipboard();

   bool OnClose(UINT aMSG)
   {
      ChangeClipboardChain(WindowHandle, Next);
      return true;
   }
   virtual bool OnCommand(UINT aId, UINT aMsg, HWND aCtrlHwnd)
   {
      if(aId == IDC_MINIMIZE && aMsg == BN_CLICKED)
      {
         Minimize();
      }
      return TRUE;
   }
   virtual bool OnMessage(UINT msg, WPARAM wParam, LPARAM lParam)
   {
      switch(msg)
      {
      case IDC_TRAY_MSG:
         if(lParam == WM_LBUTTONDOWN)
         {
            UnMinimize();
            return true;
         }
         break;
      case WM_CHANGECBCHAIN:
         OnChangeCliboardChain((HWND )wParam, (HWND )lParam);
         return true;
      case WM_DRAWCLIPBOARD:
         DrawClipboard();
         return true;
      }
      return false;
   }
   void UnMinimize();
   void Minimize();

private:
   MyDialogClass(); // Not to be implemented, use the other constructor
   HWND Parent;
   HWND Next;
   bool IsMin;
   HICON HIcon;
   HICON TrayIcon;
};

#endif
